<!DOCTYPE html>
<html <?php language_attributes(); ?>>
<head>
	<title><?php wp_title('|', true, 'right'); ?></title>
    <meta charset="<?php bloginfo( 'charset' ); ?>" />           
    <meta name="viewport" content="width=device-width, initial-scale=1">   
    <link rel="profile" href="http://gmpg.org/xfn/11" />        
    <link rel="pingback" href="<?php bloginfo( 'pingback_url' ); ?>" /> 
    <!--[if lt IE 9]>
		<script src="<?php echo get_template_directory_uri(); ?>/assets/html5shiv.js" type="text/javascript"></script>
	<![endif]-->   
    <?php if (is_singular()) wp_enqueue_script('comment-reply'); ?>    
    <?php wp_head(); ?>
</head>
<body <?php body_class(); ?>>
	<?php 
		if (has_nav_menu('nav-main')){ 
			$nav = 'nav-set';
		} else {
			$nav = 'no-nav';
		}	
	?>
	<nav id="nav-main" class="<?php echo $nav; ?>">
		<div class="container">			
			<div id="site-front" class="four columns">  
				<a id="site-front" href="<?php echo esc_url( home_url( '/' ) ); ?>"><?php bloginfo('name'); ?></a>			
			</div> 	
			<?php
			if ($nav == 'nav-set') { ?>
				<div id="primary-menu" class="twelve columns">	
					<?php wp_nav_menu(array('theme_location' => 'nav-main')); ?>		
				</div>						
			<?php }	?>						
		</div>
	</nav> 
	<?php if (is_front_page()){ ?> 
		<div id="home">     		
			<div id="site-details-holder" class="sixteen columns">						
				<div id="site-details">			    			
					<?php if (get_theme_mod('alphasource_logo')): ?>
						<img src='<?php	echo esc_url(get_theme_mod('alphasource_logo')); ?>' alt='<?php echo esc_attr(get_bloginfo('name', 'display')); ?>'>
					<?php else:	?>
						<h1><?php bloginfo('name'); ?></h1>
						<p><?php bloginfo('description');?></p>
					<?php endif; ?>
				</div>		
			</div>	    	    		
		</div> 
	<?php } ?>	