<!DOCTYPE html>
<html <?php language_attributes(); ?>>              
    <head>
        <meta charset="<?php bloginfo('charset'); ?>" />                   
        <meta name="viewport" content="width=device-width, initial-scale=1.0" />
        <title><?php kopa_print_page_title(); ?></title>                
        <link rel="pingback" href="<?php bloginfo('pingback_url'); ?>" />       
        <link rel="shortcut icon" type="image/x-icon"  href="<?php echo get_option('kopa_theme_options_favicon_url'); ?>">     
        <link rel="apple-touch-icon" sizes="57x57" href="<?php echo get_option('kopa_theme_options_apple_iphone_icon_url'); ?>">
        <link rel="apple-touch-icon" sizes="72x72" href="<?php echo get_option('kopa_theme_options_apple_ipad_icon_url'); ?>">
        <link rel="apple-touch-icon" sizes="114x114" href="<?php echo get_option('kopa_theme_options_apple_iphone_retina_icon_url'); ?>">
        <link rel="apple-touch-icon" sizes="144x144" href="<?php echo get_option('kopa_theme_options_apple_ipad_retina_icon_url'); ?>">        
        <?php wp_head(); ?>
    </head>    
    <?php $layout = get_option('kopa_theme_options_layout', 'wide'); 
    $layout = ( $layout === 'box' ? 'kopa-boxed' : '' );
    $layout .= 'heavy-dark-footer';
    ?>
    <body <?php body_class($layout); ?>>
    
        <div class="kopa-wrapper">
        
            <div class="kopa-background"></div>
            
            <header id="page-header">
                <div id="header-top">
                    <div class="wrapper">
                        <div class="row-fluid">
                            <div class="span12 clearfix">
                                <p class="hot-line"><?php echo get_option('kopa_theme_options_left_header_description'); ?></p>
                                <div class="top-box clearfix">
                                    <ul class="top-link clearfix">
                                    <?php 
                                    include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
                                    $users_can_register = get_option('users_can_register');
                                    if ( is_plugin_active( 'jigoshop/jigoshop.php' ) ) : ?>
                                        <li><?php
                                            $jigoshop_options = get_option('jigoshop_options');
                                            if ( isset($jigoshop_options['jigoshop_myaccount_page_id']) && 
                                                 is_numeric($jigoshop_options['jigoshop_myaccount_page_id']) )
                                                $my_account_page_id = $jigoshop_options['jigoshop_myaccount_page_id'];

                                            if ( ! is_user_logged_in() ) {
                                                if ( $users_can_register ) {
                                                    wp_register('', '');                                    
                                                    echo '&nbsp;/&nbsp;';
                                                }
                                                if ( isset( $my_account_page_id ) )
                                                    echo '<a href="'.get_page_link($my_account_page_id).'">'.__('Log in', kopa_get_domain()).'</a>';
                                            } else {
                                                if ( isset( $my_account_page_id ) ) {
                                                    echo '<a href="'.get_page_link($my_account_page_id).'">'.__('My Account', kopa_get_domain()).'</a>';
                                                    echo '&nbsp;/&nbsp;';
                                                }
                                                echo '<a href="'.wp_logout_url( home_url() ).'" title="'.__('Logout', kopa_get_domain()).'">'.__('Logout', kopa_get_domain()).'</a>';
                                            }
                                        ?></li>
                                        <li>
                                        <?php 
                                        $cart_contents = jigoshop_cart::$cart_contents;
                                        $total = 0;
                                        $currency = $jigoshop_options['jigoshop_currency'];
                                        $cart_page_id = $jigoshop_options['jigoshop_cart_page_id'];

                                        if ( ! empty( $cart_contents ) ) {
                                            foreach ( $cart_contents as $key => $values ) {
                                                // Get product instance
                                                $_product = $values['data'];
                                                $total += $_product->get_price() * $values['quantity'];
                                            }
                                        }

                                        if ( ! empty( $cart_page_id ) )
                                            echo '<a href="'.get_page_link( $cart_page_id ).'">';

                                        _e('Shopping Cart', kopa_get_domain()); ?> - <?php echo jigoshop_price( $total ); ?>

                                        <?php if ( ! empty( $cart_page_id ) )
                                            echo '</a>'; 
                                        ?>
                                        </li>
                                    <?php else: ?>

                                        <li><?php if ( $users_can_register ) {
                                                wp_register('', '');                                    
                                                echo '&nbsp;/&nbsp;';
                                        } 
                                        wp_loginout();
                                        ?></li>

                                    <?php endif; ?>
                                    </ul>
                                    <div class="search clearfix">
                                        <a href="#" class="search-icon" title="Search">Search</a>
                                        <?php get_search_form(); ?>
                                    </div><!--search-->
                                </div><!--top=box-->
                            </div><!--span12-->
                        </div><!--row-fluid-->
                    </div><!--wrapper-->
                </div><!--header-top-->
                
                <div id="header-bottom" class="cbp-af-header">
                    <div class="wrapper">
                        <div class="row-fluid">
                            <div class="span12 clearfix">
                                <div id="logo-image">
                                    <a href="<?php echo home_url(); ?>">
                                        <?php $logo = get_option( 'kopa_theme_options_logo_url' );
                                        if ($logo) :
                                        ?>
                                        <img src="<?php echo $logo; ?>" alt="<?php bloginfo('name'); ?> <?php _e( 'Logo', kopa_get_domain() ); ?>">
                                        <?php 
                                        endif;
                                        ?>
                                    </a>
                                </div><!--logo-image-->
                                <nav id="main-nav">
                                    <?php 

                                    if ( has_nav_menu('main-nav') ) {
                                        $main_menu_walker = new kopa_main_menu();
                                        wp_nav_menu( array(
                                            'theme_location' => 'main-nav',
                                            'container'      => '',
                                            'items_wrap'     => '<ul id="main-menu" class="clearfix">%3$s</ul>',
                                            'walker'         => $main_menu_walker
                                        ) );

                                        $mobile_menu_walker = new kopa_mobile_menu();
                                        wp_nav_menu( array(
                                            'theme_location' => 'main-nav',
                                            'container'      => 'div',
                                            'container_id'   => 'mobile-menu',
                                            'items_wrap'     => '<span>'.__( 'Menu', kopa_get_domain() ).'</span><ul id="toggle-view-menu">%3$s</ul>',
                                            'walker'         => $mobile_menu_walker
                                        ) );
                                    }
                                    ?>
                                </nav><!--main-nav-->
                            </div><!--span12-->
                        </div><!--row-fluid-->
                    </div><!--wrapper-->
                </div><!--header-bottom-->
            </header><!--page-header-->